Leetcode 338. Counting Bits

来源:互联网 发布:软件管家官方版 编辑:程序博客网 时间:2024/06/08 09:45

Given a non negative integer number num. For every numbers i in the range 0 ≤ i ≤ num calculate the number of 1’s in their binary representation and return them as an array.

Example:
For num = 5 you should return [0,1,1,2,1,2].

Follow up:

It is very easy to come up with a solution with run time O(n*sizeof(integer)). But can you do it in linear time O(n) /possibly in a single pass?
Space complexity should be O(n).
Can you do it like a boss? Do it without using any builtin function like __builtin_popcount in c++ or in any other language.
题意:给定一个非负整数num,将[0,num]内所有的整数的二进制数的bit1个数计算出来,存在一个数组中返回。
题解:显然首先想到的是暴力求解方法,从0到num,逐个mod2求取1的数位如下代码所示:

public class Solution {    public int[] countBits(int num) {        /***brute solution***/        int[] res=new int[num+1];        for(int i=0;i<res.length;i++)        {            int temp=i;            int bits=0;            while(temp!=0)            {                if(temp%2==1) bits++;                temp/=2;            }            res[i]=bits;        }        return res;     }   }

但是对于follow up 里的要求显然是不满足的。这里我们考虑求取 7的bit 1 个数:

7%2=1, bits++;7/2=33%2=1,bits++  

这里发现对7mod2后,其子问题刚好是res[3]的结果!!即res[7]=res[3]+1!因此有如下递推关系式:

res[n]=res[n/2],n%2=0res[n]=res[n/2]+1;n%2=1

用动态规划的说法,很多数都是求解公共子问题,代码如下:

public class Solution {    public int[] countBits(int num) {        /****DP solution***/        int[] res=new int[num+1];        res[0]=0;        if(num==0) return res;        res[1]=1;        for(int i=2;i<num+1;i++)        {            if(i%2==0)  res[i]=res[i/2];            else  res[i]=res[i/2]+1;        }        return res;    }}
0 0
原创粉丝点击